#                              -*- Mode: Perl -*- 
#!/app/unido-i06/magic/perl
#                              -*- Mode: Perl -*- 
use Config;
use File::Basename qw(&basename &dirname);

# List explicitly here the variables you want Configure to
# generate.  Metaconfig only looks for shell variables, so you
# have to mention them as if they were shell variables, not
# %Config entries.  Thus you write
#  $startperl
# to ensure Configure will look for $Config{startperl}.

# This forces PL files to create target in same directory as PL file.
# This is so that make depend always knows where to find PL derivatives.
chdir(dirname($0));
($file = basename($0)) =~ s/\.PL$//;
$file =~ s/\.pl$//
	if ($^O eq 'VMS' or $^O eq 'os2');  # "case-forgiving"

open OUT,">$file" or die "Can't create $file: $!";

print "Extracting $file (with variable substitutions)\n";

# In this section, perl variables will be expanded during extraction.
# You can use $Config{...} to use Configure variables.

print OUT <<"!GROK!THIS!";
$Config{'startperl'} 
!GROK!THIS!
print OUT <<'!NO!SUBS!';
# make_index -- generate index for iman
# ITIID           : $Source: Man-Index/make_index_ $ $Revision: 1.9 $
# Author          : Ulrich Pfeifer
# Created On      : Fri 25 Apr 14:19:19 1997
# Last Modified By: Ulrich Pfeifer
# Last Modified On: Sun Apr 27 12:50:02 1997
# Language        : Perl
# Status          : Demo for TPJ
# 
# (C) Copyright 1997, Ulrich Pfeifer, all rights reserved.
#
!NO!SUBS!

# In the following, perl variables are not expanded during extraction.

print OUT <<'!NO!SUBS!';
eval 'exec perl  -S $0 "$@"'
    if 0;

use Man::Index;
use Getopt::Long;
use strict;
use vars qw(%OPT $VERSION);

# $Format: "$VERSION = \"$ProjectVersion$\";"$ 
$VERSION = "0.19";

print "make_index - interactive manual search $VERSION by Ulrich Pfeifer\n";

%OPT = (
        index => '/tmp/man',
       );

GetOptions(\%OPT,
           'index=s',
           'mandir=s@',
          ) or die "USAGE: $0 [-index <path>] [-mandir <mandir>] ...\n";

$OPT{mandir} = [split /:/, ($ENV{MANPATH}?$ENV{MANPATH}:'/usr/man:/usr/local/man')]
  unless $OPT{mandir};

my $index = new Man::Index index => $OPT{'index'}, rw => 1;
die "Could not open index '$OPT{index}'\n" unless $index;

for my $dir (@{$OPT{mandir}}) {
  opendir BASE, $dir or die "Could not opendir '$dir': $!\n";
  for my $sub (grep -d  "$dir/$_", grep /^man/, readdir BASE) {
    my $path = "$dir/$sub";
    opendir SUBDIR, $path  or die "Could not opendir '$path': $!\n";
    for my $page (grep -f "$path/$_", readdir SUBDIR) {
      if (my ($number, $headline) = $index->add_document("$path/$page")) {
        print substr(sprintf("%4d ", $number).$headline, 0, 78), "\n";
      }
    }
  }
  closedir BASE;
}


!NO!SUBS!

close OUT or die "Can't close $file: $!";
chmod 0755, $file or die "Can't reset permissions for $file: $!\n";
exec("$Config{'eunicefix'} $file") if $Config{'eunicefix'} ne ':';
